//
// File:        AudioClient.java
// Author:      Tomasz Stachowiak
// e-mail:      <stach@npac.syr.edu>
// Created:     Tue Jan 14 1997
// Time-stamp: <97/01/29 18:58:03 stach>
// Copyright Tomasz Stachowiak 1997 NPAC, Syracuse University

// Description:

import java.util.*;
import java.net.*;
import java.io.*;
import java.awt.*;

public class AudioClient implements Runnable{
  static int ADD = 1;
  static int DELETE = 2;
  static int port = 23694;

  Hashtable members;

  DatagramSocket socket;

  List memberList;

  public AudioClient(Hashtable mbs, List list) {
    members = mbs;
    try {
      socket = new DatagramSocket(port);
    } catch (SocketException e) {
      System.err.println("NetProcess: " + e);
    }
    memberList = list;
  }

  protected void finalize() {
    socket.close();
  }

  private void processMessage(DatagramPacket packet) {
    byte msg[] = packet.getData();
    byte type = msg[0];

    switch(type) {
    case 1:        // ADD
      add(packet);
      break;

    case 2:        // DELETE
      delete(packet);
      break;

    default:
      System.err.println("NetProcess: wrong message type");
    }
  }

  private void add(DatagramPacket packet) {
    String name = new String("");
    String host = packet.getAddress().getHostName();
    memberList.addItem(host);
    try {
      Member mbr = new Member(name, host);
      members.put(host, mbr);
    } catch (UnknownHostException e) {
      System.err.println("NetProcess: " + e);
    }
  }

  private void delete(DatagramPacket packet) {
    String host = packet.getAddress().getHostName();
    members.remove(host);

    int i = memberList.countItems() - 1;
    while(i >= 0) {
      if(memberList.getItem(i).compareTo(host) == 0)
	memberList.delItem(i);
      i--;
    }
  }


  public void run() {
    byte[] buffer = new byte[100];
    DatagramPacket packet = new DatagramPacket(buffer, buffer.length);

    while(true) {
      try {
	socket.receive(packet);
	processMessage(packet);
      } catch (IOException e) {
	System.err.println("NetProcess: " + e);
      }
    }      
  }
}






